/*
 * generatorManager.java
 *
 * Created on 26. mars 2007, 17:25
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package my.ABB_UI;

import gnu.io.NoSuchPortException;
import java.awt.ComponentOrientation;
import java.awt.Dimension;
import java.awt.GridLayout;
import java.io.IOException;
import java.net.UnknownHostException;
import java.text.DateFormat;
import java.text.SimpleDateFormat;
import javax.swing.BoxLayout;
import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JFrame;
import javax.swing.JInternalFrame;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTable;
import javax.swing.SpringLayout;
import javax.swing.border.TitledBorder;
import org.jfree.chart.ChartFactory;
import org.jfree.chart.ChartPanel;
import org.jfree.chart.JFreeChart;
import org.jfree.chart.plot.PlotOrientation;
import org.jfree.data.time.Second;
import org.jfree.data.time.TimeSeries;
import org.jfree.data.xy.XYSeries;
import org.jfree.data.xy.XYSeriesCollection;

/**
 *
 * @author Erlend
 */
public class generatorManager extends Thread{
    /**Sring used to start a Iperf server process. */
    public String receiverCommand;
    /**String used to start Iperf client porcess. */
    public String generatorCommand;
    /**Generate report or not.*/
    public boolean generateReport;
    /**Double run or not. */
    public boolean runTwice;
    /**TCP or UDP.*/
    public int type;
    /**Show graph of bandwidth or not.*/
    public boolean plotBandwith;
    /**Show graph of delay jitter or not.*/
    public boolean plotJitter;
    /**Show graph of datagram loss or not. */
    public boolean plotLoss;
    /**The variable name of the PacketReader.*/
    private PacketReader packRd;
    /**The variable name of the PacketGenerator.*/
    private PacketGenerator packGen;
    /**The vairable name of the RxRateReader. */
    private RxRateReader rxRateReader;
    /**Used to stop the generatorManager thread.*/
    private boolean stop = false;
    /**Stores a MAC Address. NOT USED.*/
    private String macAddress;
    /**The variable name of the real-time bandwidth graph.*/
    public DynamicPlot bandwithPlot;
    /**The variable name of the real-time jitter graph. */
    public DynamicPlot jitterPlot;
    /**The variable name of the real-time datagrams loss graph.*/
    public DynamicPlot lossPlot;
    /**The variable name of the real-time data rate graph. */
    public DynamicPlot RxRatePlot;
    /**The variable name of the DataGenerator.*/
    private DataGenerator gen;
    
    /**The variable name of the Report window.*/
    public JFrame reportFrame;
    /** */
    public JFrame owner;
    /** */
    public JPanel base;
    /** */
    public JPanel graphPanel;
    /** */
    public JPanel otherPanel;
    /** */
    public JPanel summaryPanel;
    /** */
    public JPanel parametersPanel;
    /** */
    public JPanel onPanel;
    /** */
    public JPanel offPanel;
    /** */
    public JPanel diffPanel;
    /** */
    public JPanel reportPanel;
    /** */
    public JPanel savePanel;
    /**A string of the date.*/    
    public String date;
    /**The start time of the simulation.*/
    public String startTime;
    /**The end time of the simulation.*/
    public String stopTime;
    /**Total time of simulation*/
    public String totalTime;
    /**NOT USED.*/
    public boolean table;
    /**Name of the file used to configure the BS.*/
    public String fileName;
    /**The bandwidth of UDP.*/
    public String generatorBandwith;
    /**The calculation interval.*/
    public String calculationInterval;
    /**The protocol used.*/
    public String protocol;
    /**IP address of the local computer.*/
    public String localIPAdress;
    /**IP address for the remote computer.*/
    public String remoteIPAdress;
    /**Mode of the BS.*/
    public String mode;
    /**NOT USED.*/
    public int final_time;
    /**The comport used to connect the BS.*/
    public String comPort;
    /**Get data rate of AP or not.*/
    public boolean get_RxRate = false;
    /**The XYSeries containg the data of bandwidth from the first run.*/
    private XYSeries bandwithSerie_1 = null;
    /**The XYSeries containg the data of bandwidth from the second run.*/
    private XYSeries bandwithSerie_2 = null;
    /**The XYSeries containg the data of jitter from the first run. */
    private XYSeries jitterSerie_1 = null;
    /**The XYSeries containg the data of jitter from the second run. */
    private XYSeries jitterSerie_2 = null;
    /**The XYSeries containg the data of datagram loss from the first run. */
    private XYSeries lossSerie_1 = null;
    /**The XYSeries containg the data of datagram loss from the second run. */
    private XYSeries lossSerie_2 = null;
    /**The XYSeries containg the data of data rate from the first run. */
    private XYSeries rxRateSerie_1 = null;
    /**The XYSeries containg the data of data rate from the second run. */
    private XYSeries rxRateSerie_2 = null;
    /** */
    private int report_hight  = 300;
    /** */
    private int report_width = 500;
    /**Contains the channels muted at the BS.*/
    public Object[] channels;
    
    /** Creates a new instance of generatorManager.  */
    public generatorManager() {
        gen = new DataGenerator(100);  
        macAddress = "00:16:d4:ba:88:ff";
        
    }
    /**Returns maximum value. */
    public double getMaximumValue(XYSeries serie){
        double max = 0.0;
        for(int i = 1; i < serie.getItemCount(); i++){
            double temp =  serie.getDataItem(i).getY().doubleValue();
            //System.out.println(temp);
            if( temp > max){
                max = temp;
            }
        }
        
        return max;
    }
    /**Returns minimum value.*/
    public double getMinimumValue(XYSeries serie){
        double min = 1000.0;
        for(int i = 1; i < serie.getItemCount(); i++){
            double temp = serie.getDataItem(i).getY().doubleValue();
            if(temp < min){
                min = temp;
            }
        }
        return min;
    }
    /**Returns average value.*/
    public double getAverageValue(XYSeries serie){
        double sum = 0.0;
        for(int i = 1; i < serie.getItemCount(); i++){
            sum = sum + serie.getDataItem(i).getY().doubleValue();
        }
        return (sum/(serie.getItemCount()-1));
    }
    /**Creates the table when UDP has been generated.*/
    public JScrollPane createUDPTable(XYSeries bandwithSerie, XYSeries jitterSerie, XYSeries lossSerie, XYSeries rxRateSerie){
        String [] columnNames= {"", "Average", "Best", "Worst"};
        Object [][] data = {{"Bandwidth [Mbits/sec]", getAverageValue(bandwithSerie), getMaximumValue(bandwithSerie), getMinimumValue(bandwithSerie)},
            {"Jitter [ms]", getAverageValue(jitterSerie), getMaximumValue(jitterSerie), getMinimumValue(jitterSerie)},
            {"Datagram loss [%]", getAverageValue(lossSerie), getMaximumValue(lossSerie), getMinimumValue(lossSerie)},
            {"Rate [Mbits/sec]", getAverageValue(rxRateSerie), getMaximumValue(rxRateSerie), getMinimumValue(rxRateSerie)}};
        
        JTable table = new JTable(data, columnNames);
        JScrollPane scroll = new JScrollPane(table);
        scroll.setMaximumSize(new Dimension(500, 83));
        scroll.setMinimumSize(new Dimension(500,83));
        scroll.setPreferredSize(new Dimension(500,83));
        table.setPreferredScrollableViewportSize(table.getSize());
        
        return scroll;
    }
    /**Creates the table when TCP has been generated.*/
    public JScrollPane createTCPTable(XYSeries bandwithSerie, XYSeries rxRateSerie){
        String [] columnNames = {"", "Average", "Best", "Worst"};
        Object [][] data = {{"Bandwidth [Mbits/sec]", getAverageValue(bandwithSerie), getMaximumValue(bandwithSerie), getMinimumValue(bandwithSerie)},
                            {"Rate [Mbits/sec]", getAverageValue(rxRateSerie), getMaximumValue(rxRateSerie), getMinimumValue(rxRateSerie)}};
        
        
        JTable table = new JTable(data, columnNames);
        JScrollPane scroll = new JScrollPane(table);
        scroll.setMaximumSize(new Dimension(500, 53));
        scroll.setMinimumSize(new Dimension(500,53));
        scroll.setPreferredSize(new Dimension(500,53));
        table.setPreferredScrollableViewportSize(table.getSize());
        
        return scroll;
    }   
    /**Clears the real-time graphs.*/
    private void clearPlots(){
        bandwithPlot.cleaObservations();
        jitterPlot.cleaObservations();
        lossPlot.cleaObservations();
        RxRatePlot.cleaObservations();
    }
    /**Returns the current date and time.*/
    private String getTime(){
        DateFormat dateFormat = new SimpleDateFormat("yyyy/MM/dd HH:mm:ss");
        java.util.Date date = new java.util.Date();
        return dateFormat.format(date);
    }
    
    /**Displays warning if connection to the remote computer fails.*/
    private void displayWarning(){
        Object [] options = {"OK"};
        JOptionPane.showOptionDialog(null, "Connection to " + this.remoteIPAdress + " failed!", "Connection failed", JOptionPane.DEFAULT_OPTION, JOptionPane.WARNING_MESSAGE, null, options, options[0]);
                
        owner.validate();
    }
    /**Saves the results in a text file.*/
     private void saveButtonMouseClicked(java.awt.event.MouseEvent evt){
         Object [] message = {"Specify a filename"};
         String s = (String) JOptionPane.showInputDialog(reportFrame, message, "Save to file", JOptionPane.PLAIN_MESSAGE, null, null, "nameOfReportFile");
         
         try {
            WriteToFile wr = new WriteToFile(this, s);
            wr.bandwithSerie_1 = this.bandwithSerie_1; 
            wr.bandwithSerie_2 = this.bandwithSerie_2;
            wr.jitterSerie_1 = this.jitterSerie_1;
            wr.jitterSerie_2 = this.jitterSerie_2;
            wr.lossSerie_1 = this.lossSerie_1;
            wr.lossSerie_2 = this.lossSerie_2;
            wr.rxRateSerie_1 = this.rxRateSerie_1;
            wr.rxRateSerie_2 = this.rxRateSerie_2;
            wr.channels = this.channels;
            
            wr.writeTo();
        } catch (IOException ex) {
            ex.printStackTrace();
        }         
     }

    public void run(){
        
        //Creating the basic GUI

        reportFrame = new JFrame();
        reportFrame.setAlwaysOnTop(false);
                
        base = new JPanel(true);
        base.setLayout(new BoxLayout(base, javax.swing.BoxLayout.Y_AXIS));
        reportFrame.getContentPane().add(base);
        
        reportPanel = new JPanel(true);
        reportPanel.setLayout(new BoxLayout(reportPanel, javax.swing.BoxLayout.X_AXIS));
        base.add(reportPanel);
        
        savePanel = new JPanel(true);
        savePanel.setLayout(new BoxLayout(savePanel, javax.swing.BoxLayout.X_AXIS));
        base.add(savePanel);
        
        JButton saveButton = new JButton();
        saveButton.setText("Save report");
        saveButton.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                saveButtonMouseClicked(evt);
            }
        });
        
        savePanel.add(saveButton);
        
        otherPanel = new JPanel(true);
        otherPanel.setLayout(new BoxLayout(otherPanel, javax.swing.BoxLayout.Y_AXIS));
        reportPanel.add(otherPanel);
        
        graphPanel = new JPanel(true);
        graphPanel.setLayout(new BoxLayout(graphPanel, javax.swing.BoxLayout.Y_AXIS));
        reportPanel.add(graphPanel);
        
        summaryPanel = new JPanel(true);

        summaryPanel.setLayout(new BoxLayout(summaryPanel, javax.swing.BoxLayout.Y_AXIS));
        summaryPanel.setBorder(javax.swing.BorderFactory.createTitledBorder("Summary"));
        
        parametersPanel = new JPanel(new GridLayout(0, 1, 6, 6), true);
        parametersPanel.setMaximumSize(new Dimension(400,300));
        parametersPanel.setComponentOrientation(ComponentOrientation.LEFT_TO_RIGHT);
        parametersPanel.setBorder(javax.swing.BorderFactory.createTitledBorder("General information"));
        
        JLabel startLabel = new JLabel("Start time: ");
        parametersPanel.add(startLabel);
                
        JLabel stopLabel = new JLabel("Stop time: ");
        parametersPanel.add(stopLabel);
        
        JLabel emptyLabel_1 = new JLabel("");
        parametersPanel.add(emptyLabel_1);
        
        JLabel protocolLabel = new JLabel("Protocol: " + protocol);
        parametersPanel.add(protocolLabel);
        
        JLabel bandwithLabel = new JLabel("Bandwith: " + generatorBandwith + "Mbits/sec");
        parametersPanel.add(bandwithLabel);
        
        JLabel intervalLabel = new JLabel("Calculation interval: " + calculationInterval + "s");
        parametersPanel.add(intervalLabel);
        
        JLabel localIPLabel = new JLabel("Local IP adress: " + localIPAdress);
        parametersPanel.add(localIPLabel);
        
        JLabel remoteIPLabel = new JLabel("Remote IP adress: " + remoteIPAdress);
        parametersPanel.add(remoteIPLabel);
        
        JLabel emptyLabel_2 = new JLabel("");
        parametersPanel.add(emptyLabel_2);
        
        JLabel modeLabel = new JLabel("WISA BS mode: " + mode);
        parametersPanel.add(modeLabel);
        
        JLabel fileNameLabel = new JLabel("File name: " + fileName);
        parametersPanel.add(fileNameLabel);
        
        //First case; only one run.
        gen.setType(type);        
        gen.resetSeries();
        
        // If a report is not desired, only real-time feedback.
        if(!generateReport){
            clearPlots();
            
            //Create new packet reader and generator.
            try {
                packRd = new PacketReader();
                packGen = new PacketGenerator(this.localIPAdress, this.remoteIPAdress);
                rxRateReader = new RxRateReader();
                rxRateReader.macAddress= this.macAddress;
            } catch (UnknownHostException ex) {
                ex.printStackTrace();
            }
            catch (IOException ex) {
                displayWarning();
                stop = true;                
            }
            
           if(!stop){
                // Tells the packet reader UDP/TCP
                packRd.setType(type);
                // Gives the iperf command to the packet reader and generator.
                packRd.setReceiverCommand(receiverCommand);
                packGen.setGeneratorCommand(generatorCommand);
                if(this.get_RxRate){
                    rxRateReader.start();
                }
                // Gives the generator the plots and the reader, then starts it.
                gen.setPlot(bandwithPlot, jitterPlot, lossPlot, this.RxRatePlot);
                gen.setReader(packRd);
                gen.setRxReader(rxRateReader);
                gen.start();       
            
                // Starts the packet reader and packet generator.
            
                startTime = getTime();
            
                packRd.final_time = this.final_time;
                packRd.start();
                packGen.start();
                
                
                // waits till the packet reader is finished.
                while(packRd.isAlive()){
                    try {
                        this.sleep(100);
                    } catch (InterruptedException ex) {
                        ex.printStackTrace();
                    }
                }
            
                stopTime = getTime();
                rxRateReader.keepRunning = false;
            }
        }
        if(generateReport){
            
            if(!runTwice){
                clearPlots();
            
               //Create new packet reader and generator.
                try {
                    packRd = new PacketReader();
                    packGen = new PacketGenerator(this.localIPAdress, this.remoteIPAdress);
                    rxRateReader = new RxRateReader();
                    rxRateReader.macAddress = this.macAddress;
                } catch (UnknownHostException ex) {
                    ex.printStackTrace();
                }
                catch (IOException ex) {
                    displayWarning();
                    stop = true;                
                }            
                if(!stop){
                    // Tells the packet reader UDP/TCP
                    packRd.setType(type);
                    // Gives the iperf command to the packet reader and generator.
                    packRd.setReceiverCommand(receiverCommand);
                    packGen.setGeneratorCommand(generatorCommand);
                    if(this.get_RxRate){
                        rxRateReader.start();
                    }
                    // Gives the generator the plots and the reader, then starts it.
                    gen.setPlot(bandwithPlot, jitterPlot, lossPlot, this.RxRatePlot);
                    gen.setReader(packRd);
                    gen.setRxReader(rxRateReader);
                    gen.start();       
            
                    // Starts the packet reader and packet generator.
                    startTime = getTime();
                    packRd.final_time = this.final_time;
                
                    packRd.start();
                    packGen.start();
            
                    // waits till the packet reader is finished.
                    while(packRd.isAlive()){
                        try {
                            this.sleep(100);
                        } catch (InterruptedException ex) {
                            ex.printStackTrace();
                        }
                    }
                    rxRateReader.keepRunning = false;
                    stopTime = getTime();
                
                    // If UDP
                    if(type == 1){
                        bandwithSerie_1 = gen.getBandwithSerie(1);
                        jitterSerie_1 = gen.getJitterSerie(1);
                        lossSerie_1 = gen.getLossSerie(1);
                        rxRateSerie_1 = gen.getRxRateSerie(1);
                    
                        XYSeriesCollection bandwithData = new XYSeriesCollection();
                        bandwithData.addSeries(bandwithSerie_1);
                    
                        XYSeriesCollection jitterData = new XYSeriesCollection();
                        jitterData.addSeries(jitterSerie_1);
                    
                        XYSeriesCollection lossData = new XYSeriesCollection();
                        lossData.addSeries(lossSerie_1);
                        
                        XYSeriesCollection rxRateData = new XYSeriesCollection();
                        rxRateData.addSeries(rxRateSerie_1);
                    
                        JFreeChart bandwithChart = ChartFactory.createXYLineChart("Bandwidth", "Time [s]", "Mbits/sec", bandwithData, PlotOrientation.VERTICAL, false, true, false);
                        JFreeChart jitterChart = ChartFactory.createXYLineChart("Jitter", "Time [s]", "ms", jitterData, PlotOrientation.VERTICAL, false, true, false);
                        JFreeChart lossChart = ChartFactory.createXYLineChart("Datagram loss", "Time [s]", "%", lossData, PlotOrientation.VERTICAL, false, true, false);
                        JFreeChart rxRateChart = ChartFactory.createXYLineChart("Rate", "Time [s]", "Mbits/sec", rxRateData, PlotOrientation.VERTICAL, false, true, false);
                        
                        ChartPanel bandwithPanel = new ChartPanel(bandwithChart);
                        bandwithPanel.setPreferredSize(new Dimension(report_width, report_hight));
                        bandwithPanel.setMaximumSize(new Dimension(report_width, report_hight));
                    
                        ChartPanel jitterPanel = new ChartPanel(jitterChart);
                        jitterPanel.setPreferredSize(new Dimension(report_width, report_hight));
                        jitterPanel.setMaximumSize(new Dimension(report_width, report_hight));
                    
                        ChartPanel lossPanel = new ChartPanel(lossChart);
                        lossPanel.setPreferredSize(new Dimension(report_width, report_hight));
                        lossPanel.setMaximumSize(new Dimension(report_width, report_hight));
                        
                        ChartPanel ratePanel = new ChartPanel(rxRateChart);
                        ratePanel.setPreferredSize(new Dimension(report_width, report_hight));
                        ratePanel.setMaximumSize(new Dimension(report_width, report_hight));
                        
                        //System.out.println("hei");
                        graphPanel.add(bandwithPanel);
                        graphPanel.add(jitterPanel);
                        graphPanel.add(lossPanel);
                        graphPanel.add(ratePanel);
                        JScrollPane udpTable = createUDPTable(bandwithSerie_1, jitterSerie_1, lossSerie_1, rxRateSerie_1);
                    
                        JPanel tabelPanel = new JPanel();
                        tabelPanel.add(udpTable);
                        tabelPanel.setBorder(javax.swing.BorderFactory.createTitledBorder("Basestation ON"));
                        tabelPanel.setLayout(new BoxLayout(tabelPanel, javax.swing.BoxLayout.X_AXIS));
                        summaryPanel.add(tabelPanel);

                    } //End UDP
                
                    // If TCP
                    if(type == 2){
                        bandwithSerie_1 = gen.getBandwithSerie(1);
                        rxRateSerie_1 = gen.getRxRateSerie(1);
                        
                        XYSeriesCollection bandwithData = new XYSeriesCollection();
                        bandwithData.addSeries(bandwithSerie_1);
                    
                        XYSeriesCollection rxRateData = new XYSeriesCollection();
                        rxRateData.addSeries(rxRateSerie_1);
                    
                        JFreeChart bandwithChart = ChartFactory.createXYLineChart("Bandwidth", "Time [s]", "Mbits/sec", bandwithData, PlotOrientation.VERTICAL, false, true, false);
                        JFreeChart rateChart = ChartFactory.createXYLineChart("Rate", "Time [s]", "Mbits/sec", rxRateData, PlotOrientation.VERTICAL, false, true, false);
                        
                        ChartPanel bandwithPanel = new ChartPanel(bandwithChart);
                        bandwithPanel.setPreferredSize(new Dimension(report_width, report_hight));
                        bandwithPanel.setMaximumSize(new Dimension(report_width, report_hight));
                    
                        ChartPanel ratePanel = new ChartPanel(rateChart);
                        ratePanel.setPreferredSize(new Dimension(report_width, report_hight));
                        ratePanel.setMaximumSize(new Dimension(report_width, report_hight));
                    
                        
                        graphPanel.add(bandwithPanel);
                        graphPanel.add(ratePanel);
                        
                        JScrollPane table = createTCPTable(bandwithSerie_1, rxRateSerie_1);
                    
                        JPanel tabelPanel = new JPanel();
                        tabelPanel.add(table);
                        tabelPanel.setBorder(javax.swing.BorderFactory.createTitledBorder("Basestation ON"));
                        tabelPanel.setLayout(new BoxLayout(tabelPanel, javax.swing.BoxLayout.Y_AXIS));
                        summaryPanel.add(tabelPanel);
                            
                    }// End TCP
                rxRateReader.keepRunning = false;
                }//End run once
            }
            
            if(runTwice){
                clearPlots();
                try {
                    packRd = new PacketReader();
                    packGen = new PacketGenerator(this.localIPAdress, this.remoteIPAdress);
                    rxRateReader = new RxRateReader();
                    rxRateReader.macAddress = this.macAddress;
                } catch (UnknownHostException ex) {
                    ex.printStackTrace();
                }catch (IOException ex) {
                    displayWarning();
                    stop = true;                
                }   
                if(!stop){
                    packRd.setType(type);
                    packRd.setReceiverCommand(receiverCommand);
                    packGen.setGeneratorCommand(generatorCommand);
                    if(this.get_RxRate){
                        rxRateReader.start();
                    }
                    
                    gen.setPlot(bandwithPlot, jitterPlot, lossPlot, this.RxRatePlot);
                    gen.setReader(packRd);
                    gen.setRxReader(rxRateReader);
                    gen.start();
            
                    startTime = getTime();
                
                    packRd.final_time = this.final_time;
                
                    packRd.start();
                    packGen.start();
            
            
                    while(packRd.isAlive()){
                        try {
                            this.sleep(100);
                        } catch (InterruptedException ex) {
                            ex.printStackTrace();
                        }
                    }
                    rxRateReader.keepRunning = false;
                    gen.hasRun = true;
                
                    // If UDP
                    if(type == 1){
                        bandwithSerie_1 = gen.getBandwithSerie(1);
                        bandwithSerie_1.setDescription("Basestation ON");
                
                        jitterSerie_1 = gen.getJitterSerie(1);
                        jitterSerie_1.setDescription("Basestation ON");
                
                        lossSerie_1 = gen.getLossSerie(1);
                        lossSerie_1.setDescription("Basestation ON");
                        
                        rxRateSerie_1 = gen.getRxRateSerie(1);
                        rxRateSerie_1.setDescription("Basestation ON");
            
                        clearPlots();
                        try {
                            packRd = new PacketReader();
                            packGen = new PacketGenerator(this.localIPAdress, this.remoteIPAdress);
                            rxRateReader = new RxRateReader();
                            rxRateReader.macAddress = this.macAddress;
                        } catch (UnknownHostException ex) {
                            ex.printStackTrace();
                        }catch (IOException ex) {
                            displayWarning();
                            stop = true;                
                        }   
                        if(!stop){
                            wisaBS basestation = new wisaBS();
                            basestation.turnOFF();
                    
                            wisaBSwriter writer = new wisaBSwriter(basestation, comPort);
                            try {
                                writer.connect(comPort);
                            } catch (NoSuchPortException ex) {
                                ex.printStackTrace();
                            }
                            writer.run();
                                    
                            packRd.setType(type);
                            packRd.setReceiverCommand(receiverCommand);
                            if(this.get_RxRate){
                                rxRateReader.start();
                            }
                            packGen.setGeneratorCommand(generatorCommand);
            
                            gen.setPlot(bandwithPlot, jitterPlot, lossPlot, this.RxRatePlot);
                            gen.setReader(packRd);
                            gen.setRxReader(rxRateReader);
                            gen.start();
                    
                            while(writer.isAlive()){
                                try {
                                    sleep(100);
                                } catch (InterruptedException ex) {
                                    ex.printStackTrace();
                                }
                            }
                            try {
                        
                                sleep(10000);
                            } catch (InterruptedException ex) {
                                ex.printStackTrace();
                            }
                    
                            packRd.final_time = this.final_time;
                            packRd.start();
                            packGen.start();
                
                            XYSeriesCollection bandwithData = new XYSeriesCollection();
                            bandwithData.addSeries(bandwithSerie_1);
                
                            XYSeriesCollection jitterData = new XYSeriesCollection();
                            jitterData.addSeries(jitterSerie_1);                
                
                            XYSeriesCollection lossData = new XYSeriesCollection();
                            lossData.addSeries(lossSerie_1);
                            
                            XYSeriesCollection rxRateData = new XYSeriesCollection();
                            rxRateData.addSeries(rxRateSerie_1);
                                                
                            while(packRd.isAlive()){
                                try {
                                    this.sleep(100);
                                } catch (InterruptedException ex) {
                                    ex.printStackTrace();
                                }   
                            }                
                            rxRateReader.keepRunning = false;
                            stopTime = getTime();
                    
                            bandwithSerie_2 = gen.getBandwithSerie(2);
                            bandwithSerie_2.setDescription("Basestation OFF");

                            jitterSerie_2 = gen.getJitterSerie(2);
                            jitterSerie_2.setDescription("Basestation OFF");

                            lossSerie_2 = gen.getLossSerie(2);
                            lossSerie_2.setDescription("Basestation OFF");
                            
                            rxRateSerie_2 = gen.getRxRateSerie(2);
                            rxRateSerie_2.setDescription("Basestation OFF");

                            bandwithData.addSeries(bandwithSerie_2);                                        
                            jitterData.addSeries(jitterSerie_2);                    
                            lossData.addSeries(lossSerie_2);
                            rxRateData.addSeries(rxRateSerie_2);

                            JFreeChart bandwithChart = ChartFactory.createXYLineChart("Bandwidth", "Time [s]", "Mbits/sec", bandwithData, PlotOrientation.VERTICAL, true, true, false);
                            JFreeChart jitterChart = ChartFactory.createXYLineChart("Jitter", "Time [s]", "ms", jitterData, PlotOrientation.VERTICAL, true, true, false);
                            JFreeChart lossChart = ChartFactory.createXYLineChart("Loss", "Time [s]", "%", lossData, PlotOrientation.VERTICAL, true, true, false);
                            JFreeChart rateChart = ChartFactory.createXYLineChart("Rate", "Time [s]", "Mbits/sec", rxRateData, PlotOrientation.VERTICAL, true, true, false);

                            ChartPanel bandwithPanel = new ChartPanel(bandwithChart);
                            bandwithPanel.setPreferredSize(new Dimension(report_width, report_hight));
                            bandwithPanel.setMaximumSize(new Dimension(report_width, report_hight));

                            ChartPanel jitterPanel = new ChartPanel(jitterChart);
                            jitterPanel.setPreferredSize(new Dimension(report_width, report_hight));
                            jitterPanel.setMaximumSize(new Dimension(report_width, report_hight));

                            ChartPanel lossPanel = new ChartPanel(lossChart);
                            lossPanel.setPreferredSize(new Dimension(report_width, report_hight));
                            lossPanel.setMaximumSize(new Dimension(report_width, report_hight));
                            
                            ChartPanel ratePanel = new ChartPanel(rateChart);
                            ratePanel.setPreferredSize(new Dimension(report_width, report_hight));
                            ratePanel.setMaximumSize(new Dimension(report_width, report_hight));

                            graphPanel.add(bandwithPanel);
                            graphPanel.add(jitterPanel);
                            graphPanel.add(lossPanel);
                            graphPanel.add(ratePanel);

                            JScrollPane table_1 = createUDPTable(bandwithSerie_1, jitterSerie_1, lossSerie_1, rxRateSerie_1);
                            JPanel tabelPanel_1 = new JPanel();
                            tabelPanel_1.setLayout(new BoxLayout(tabelPanel_1, javax.swing.BoxLayout.X_AXIS));
                            tabelPanel_1.add(table_1);
                            tabelPanel_1.setBorder(javax.swing.BorderFactory.createTitledBorder("Basestation ON"));
                            summaryPanel.add(tabelPanel_1);

                            JScrollPane table_2 = createUDPTable(bandwithSerie_2, jitterSerie_2, lossSerie_2, rxRateSerie_2);
                            JPanel tabelPanel_2 = new JPanel();
                            tabelPanel_2.setLayout(new BoxLayout(tabelPanel_2, javax.swing.BoxLayout.X_AXIS));
                            tabelPanel_2.add(table_2);
                            tabelPanel_2.setBorder(javax.swing.BorderFactory.createTitledBorder("Basestation OFF"));
                            summaryPanel.add(tabelPanel_2);

                            summaryPanel.validate();
                            gen.hasRun = false;

                        }// End UDP
                        rxRateReader.keepRunning = false;
                    }
                
                //If TCP
                    if(type == 2){
                        bandwithSerie_1 = gen.getBandwithSerie(1);
                        bandwithSerie_1.setDescription("Basestation ON");
                        
                        rxRateSerie_1 = gen.getRxRateSerie(1);
                        rxRateSerie_1.setDescription("Basestation ON");
                        
                        clearPlots();
                        try {
                            packRd = new PacketReader();
                            packGen = new PacketGenerator(this.localIPAdress, this.remoteIPAdress);
                            rxRateReader = new RxRateReader();
                            rxRateReader.macAddress = this.macAddress;
                        } catch (UnknownHostException ex) {
                            ex.printStackTrace();

                        }catch (IOException ex) {
                            ex.printStackTrace();
                        }

                        wisaBS basestation = new wisaBS();
                        basestation.turnOFF();

                        wisaBSwriter writer = new wisaBSwriter(basestation, comPort);
                            try {
                                writer.connect(comPort);
                            } catch (NoSuchPortException ex) {
                                ex.printStackTrace();
                            }
                        writer.run();

                        while(writer.isAlive()){
                            try {
                                sleep(100);
                            } catch (InterruptedException ex) {
                                ex.printStackTrace();
                            }
                        }

                        packRd.setType(type);
                        packRd.setReceiverCommand(receiverCommand);
                        packGen.setGeneratorCommand(generatorCommand);
                        if(this.get_RxRate){
                            rxRateReader.start();
                        }
                        gen.setPlot(bandwithPlot, jitterPlot, lossPlot, this.RxRatePlot);
                        gen.setReader(packRd);
                        gen.setRxReader(rxRateReader);
                        gen.start();

                        packRd.final_time = this.final_time;
                        packRd.start();
                        packGen.start();

                        XYSeriesCollection bandwithData = new XYSeriesCollection();
                        bandwithData.addSeries(bandwithSerie_1);
                        
                        XYSeriesCollection rateData = new XYSeriesCollection();
                        rateData.addSeries(rxRateSerie_1);
                        
                        
                        while(packRd.isAlive()){
                            try {
                                this.sleep(100);
                            } catch (InterruptedException ex) {
                                ex.printStackTrace();
                            }   
                        }                
                        rxRateReader.keepRunning = false;
                        stopTime = getTime();

                        bandwithSerie_2 = gen.getBandwithSerie(2);
                        bandwithSerie_2.setDescription("Basestation OFF");
                        
                        rxRateSerie_2 = gen.getRxRateSerie(2);
                        rxRateSerie_2.setDescription("Basestation OFF");

                        bandwithData.addSeries(bandwithSerie_2);        
                        rateData.addSeries(rxRateSerie_2);

                        JFreeChart bandwithChart = ChartFactory.createXYLineChart("Bandwidth", "Time [s]", "Mbits/sec", bandwithData, PlotOrientation.VERTICAL, true, true, false);
                        JFreeChart rateChart = ChartFactory.createXYLineChart("Rate", "Time [s]", "Mbits/sec", rateData, PlotOrientation.VERTICAL, true, true, false);

                        ChartPanel bandwithPanel = new ChartPanel(bandwithChart);
                        bandwithPanel.setPreferredSize(new Dimension(report_width, report_hight));
                        bandwithPanel.setMaximumSize(new Dimension(report_width, report_hight));

                        ChartPanel ratePanel = new ChartPanel(rateChart);
                        ratePanel.setPreferredSize(new Dimension(report_width, report_hight));
                        ratePanel.setMaximumSize(new Dimension(report_width, report_hight));                        

                        graphPanel.add(bandwithPanel);
                        graphPanel.add(ratePanel);

                        JScrollPane table_1 = createTCPTable(bandwithSerie_1, rxRateSerie_1);
                        JPanel tabelPanel_1 = new JPanel();
                        tabelPanel_1.setLayout(new BoxLayout(tabelPanel_1, javax.swing.BoxLayout.X_AXIS));
                        tabelPanel_1.add(table_1);
                        tabelPanel_1.setBorder(javax.swing.BorderFactory.createTitledBorder("Basestation ON"));
                        summaryPanel.add(tabelPanel_1);


                        JScrollPane table_2 = createTCPTable(bandwithSerie_2, rxRateSerie_2);
                        JPanel tabelPanel_2 = new JPanel();
                        tabelPanel_2.setLayout(new BoxLayout(tabelPanel_2, javax.swing.BoxLayout.X_AXIS));
                        tabelPanel_2.add(table_2);
                        tabelPanel_2.setBorder(javax.swing.BorderFactory.createTitledBorder("Basestation OFF"));
                        summaryPanel.add(tabelPanel_2);


                        gen.hasRun = false;
                    } //End TCP
                    rxRateReader.keepRunning = false;
                }
            }//End run twice
            if(!stop){
                startLabel.setText("Start time: " + startTime);
                stopLabel.setText("Stop time: " + stopTime);

                otherPanel.add(parametersPanel);        

                graphPanel.validate();
                otherPanel.add(summaryPanel);
                summaryPanel.validate();

                parametersPanel.validate();

                reportFrame.pack();
                reportFrame.setVisible(true);
                reportFrame.setAlwaysOnTop(false);
                

            }//End generate report
        }        
        
    } //End run        

}
    

